<?php

function CheckAbilityOfInstallation()
{
  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  // check if all files are writeable
  $files = file($GLOBALS['TMP_FOLDER']."files.txt");
  foreach ($files as $file)
  {
     $file = $GLOBALS['DOCUMENT_ROOT'].rtrim($file);
     if (file_exists($file))
     {
        if (!is_writable($file)) // file is not writable
        {
           $result['ErrorMessage'] = "<b>         netcat.</b><br><small>($file   )</small>";
           $result['Success'] = 0;
        }
     }
     else // check dir
     {
        $dirname = dirname($file);
        // find the nearest existing parent directory
        while (!file_exists($dirname))
        {
           $dirname = preg_replace("!/[^/]+$!", "", $dirname);
           if ($dirname=="$GLOBALS[DOCUMENT_ROOT]/netcat") break;
        }

        if (!is_writable($dirname)) // directory is not writable
        {
           $result['ErrorMessage'] = "<b>      $GLOBALS[DOCUMENT_ROOT]/netcat   .</b><br><small>($dirname   )</small>";
           $result['Success'] = 0;
        }
     }
  }


  return $result;
}

function InstallPatch()
{
  global $DOCUMENT_ROOT, $TMP_FOLDER;

  $result['Success'] = 1;
  $result['ErrorMessage'] = '!';

  return $result;
}

?>