<?php
/* $Id: subdivision.inc.php,v 1.6 2006/05/24 12:17:26 volodya Exp $ */

@include_once('../vars.inc.php');
require($ADMIN_FOLDER.'consts.inc.php');

function UpdateHiddenURL ($parent_url, $parent_sub, $catalogue) {
    global $db;

    $res = $db->get_results("SELECT EnglishName,Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID='$parent_sub' AND Catalogue_ID='$catalogue'",ARRAY_N);
    $subCount = $db->num_rows;
    for ($i=0; $i<$subCount; $i++) list($english_name[$i],$sub_id[$i]) = $res[$i];

    for ($i=0; $i<$subCount; $i++) {
        $new_parent_url = $parent_url.$english_name[$i]."/";

        $res = $db->query("UPDATE Subdivision SET Hidden_URL = '".$new_parent_url."',LastUpdated=LastUpdated where Subdivision_ID='".$sub_id[$i]."'");
        UpdateHiddenURL($new_parent_url, $sub_id[$i], $catalogue);
    }
}

function GetHiddenURL ($SubdivisionID) {
    global $db;
    $hidden_url = $db->get_var("SELECT Hidden_URL FROM Subdivision WHERE Subdivision_ID='".$SubdivisionID."'");
    return $hidden_url;
}

function UpdateSubdivisionName ($SubdivisionID, $SubdivisionName)
{
    global $db;

    $update = "UPDATE Subdivision SET Subdivision_Name='";
    $update .= htmlspecialchars($SubdivisionName)."' WHERE Subdivision_ID='".$SubdivisionID."'";
    $UpdateResult = $db->query ($update);
    if ($UpdateResult)
    print '   .<br>';
    else
    print '   . !<br>';
}

function UpdateParentSubID($SubdivisionID, $NewParentSubID)
{
    global $db;

    $update  = "UPDATE Subdivision SET Parent_Sub_ID='{$NewParentSubID}' ";
    $update .= "WHERE Subdivision_ID='{$SubdivisionID}'";
    $Result = $db->query($update);
    if ($Result)
    return 1;
    else
    return 0;
}

function IsSubdivisionExist($SubdivisionID)
{
    global $db;
    $select = "SELECT Subdivision_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'";
    $Result = $db->query ($select);
    $num_rows = $db->num_rows;
    if ($num_rows > 0)
    return 1;
    else
    return 0;
}

function ChildrenNumber($SubdivisionID)
{
    global $db;
    $Array = $db->get_var("SELECT COUNT(Subdivision_ID) FROM Subdivision WHERE Parent_Sub_ID='{$SubdivisionID}'");
    return $Array;
}

function GetParentSubID($SubdivisionID)
{
    global $db;
    $ResultArray = $db->get_var("SELECT Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'");
    return $ResultArray;
}

function GetSubClassCount($SubdivisionID)
{
    global $db;
    $ResultArray = $db->get_var( "SELECT COUNT(*) FROM Sub_Class WHERE Subdivision_ID='{$SubdivisionID}'");
    return $ResultArray;
}

function DeleteFromSubClass($SubdivisionID)
{
    global $db;

    $delete = "DELETE FROM Sub_Class WHERE Subdivision_ID='{$SubdivisionID}'";
    $db->query($delete);
}

function DeleteFromPermission ($SubdivisionID)
{
    global $db;

    $delete = "DELETE FROM Permission WHERE AdminType=";
    $delete .= SUBDIVISION_ADMIN;
    $delete .= " AND Catalogue_ID='{$SubdivisionID}'";

    $db->query($delete);
}

function DeleteMessages($SubdivisionID)
{
    global $db;

    $ClassResult = $db->get_col("SELECT Class_ID FROM Class WHERE Class_ID<>0 AND System_Table_ID=0");

    if ($ClassResult)
		foreach ($ClassResult as $ClassID)
		{
			$DeleteMessage = "DELETE FROM Message".$ClassID." WHERE Subdivision_ID='{$SubdivisionID}'";
			$res = $db->query ($DeleteMessage);
		}
    else
	    return;


}

/*

function DeleteMessages($SubdivisionID)
{
  global $LinkID;

  $ClassResult = mysql_query("SELECT Class_ID FROM Class WHERE Class_ID<>0", $LinkID);

  if ($count=mysql_num_rows($ClassResult))
	for($i=0;$i<$count;$i++) list($ClassID[$i]) = mysql_fetch_row($ClassResult);
  else
	return;

  @mysql_free_result($ClassResult);

  for ($i=0;$i<$count;$i++) {
    $DeleteMessage = "DELETE FROM Message".$ClassID[$i]." WHERE Subdivision_ID='{$SubdivisionID}'";
    $res = mysql_query ($DeleteMessage, $LinkID);
  }
}

*/


class SubdivisionLocation
{
    var $CatalogueID, $ParentSubID, $SubdivisionID;

    function SubdivisionLocation ()
    {
        global $CatalogueID, $ParentSubID, $SubdivisionID;
        global $db;

        if ($SubdivisionID)
        {
            $this->SubdivisionID = $SubdivisionID;
            $Array = $db->get_row("SELECT Catalogue_ID, Parent_Sub_ID FROM Subdivision WHERE Subdivision_ID='{$SubdivisionID}'",ARRAY_A);
            $this->ParentSubID = $Array['Parent_Sub_ID'];
            $this->CatalogueID = $Array['Catalogue_ID'];
        }
        else
        {
            $this->SubdivisionID = 0;

            if (isset($ParentSubID) && $ParentSubID)
            $this->ParentSubID = $ParentSubID;
            else
            $this->ParentSubID = 0;

            if ($this->ParentSubID)
            {
                $this->CatalogueID = $db->get_var("SELECT Catalogue_ID FROM Subdivision WHERE Subdivision_ID='".$this->ParentSubID."'");
            }
            else
            {
                if (isset($CatalogueID) && $CatalogueID)
                $this->CatalogueID = $CatalogueID;
                else
                $this->CatalogueID = 0;
            }
        }
    }

    function printVars ()
    {
        print "SubdivisionLocation.CatalogueID=".$this->CatalogueID."<br>\n";
        print "SubdivisionLocation.ParentSubID=".$this->ParentSubID."<br>\n";
        print "SubdivisionLocation.SubdivisionID=".$this->SubdivisionID."<br>\n";
    }
}

function IsAllowedSubdivisionEnglishName($EnglishName, $ParentSubID, $SubdivisionID, $CatalogueID)
{
    global $db;

    if (!$EnglishName) return 0;

    $select  = "SELECT EnglishName FROM Subdivision WHERE EnglishName='".$EnglishName."' AND Parent_Sub_ID='".$ParentSubID."'";
    $select .= " AND EnglishName<>'' AND Subdivision_ID<>'".$SubdivisionID."' AND Catalogue_ID='".$CatalogueID."'";

    $Result = $db->query($select);
    $num_rows = $db->num_rows;

    if ($num_rows == 0)  return 1;

    return 0;
}

function CascadeDeleteSubdivision($SubdivisionID)
{
    global $db;

    $LockQuery = 'LOCK TABLES Subdivision WRITE, Class WRITE, Sub_Class WRITE, Permission WRITE';

    $ClassSelect = 'SELECT Class_ID FROM Class WHERE System_Table_ID=0';
    $ClassResult = $db->get_results ($ClassSelect, ARRAY_N);
    foreach ($ClassResult as $ClassArray  ) $LockQuery .= ", Message".$ClassArray[0]." WRITE";

    $LockResult = $db->query ($LockQuery);

    $delete = "DELETE FROM Subdivision WHERE Subdivision_ID='".$SubdivisionID."'";

    $CheckArray = $db->get_var("SELECT Subdivision_ID FROM Subdivision WHERE Parent_Sub_ID='".$SubdivisionID."'");

    if ($CheckArray[0] != 0) {
        print '<b>  ,      !</b>';
        return;
    }

    if ( $db->query ($delete)) {
        DeleteFromSubClass($SubdivisionID);
        DeleteFromPermission($SubdivisionID);
        DeleteMessages($SubdivisionID);
    }

    $db->query('UNLOCK TABLES');
}

?>