<?php
/* $Id: s_common.inc.php,v 1.11 2006/08/21 14:45:46 kx Exp $ */

#    ,    $tempate
function listQuery($query, $template="")
{
    global $db,$SHOW_MYSQL_ERRORS;
	//      ,      
	$db->hide_errors();

	//  
    $res = $db->get_results($query,ARRAY_A);

	//  ,  
	if ($db->captured_errors)
		$result = "<hr size=1 color=#CCCCCC><b>Query:</b> ".$db->captured_errors[0][query]."<br><br><b>Error:</b> ".$db->captured_errors[0][error_str]."<hr size=1 color=#CCCCCC><br>";

	//    MySQL ,    
	if ($SHOW_MYSQL_ERRORS=='on')
		$db->show_errors();


    if ($res && $template)
    {
		$i=0;
        foreach ($res as $data)
        {
            eval("\$result .= \"$template\";");
			$i++;
        }
    }
    return $result;
}



#  
function listLoop($from, $to, $step, $template)
{
    for ($i=$from; $i<$to; $i+=$step) eval("\$result .= \"$template\";");
    return $result;
}



#        
function nc_list_select($classificator_name, $field_name = NULL, $current_value = NULL,
$sort_type = NULL, $sort_direction = NULL, $template_prefix = NULL, $template_object = NULL, $template_suffix = NULL, $template_any = NULL)
{
    global $db, $classID;
    $result = "";

	if ($field_name)
	{
		$sql = "SELECT
					Field_ID,
					NotNull,
					System_Table_ID
				FROM Field
				WHERE
					Class_ID=".$classID."
					AND Field_Name='".$field_name."'
				";
		$field =  $db->get_row($sql);
		if (!$field)
			return "<span style='color:red;'>Error: Incorrect Field Name (".$field_name.") in function nc_list_select().</span><br>";
	}


    $k = "SELECT Sort_Type, Sort_Direction FROM Classificator WHERE Table_Name='";
    $k .= $classificator_name . "'";

    $s = "SELECT ${classificator_name}_ID, ${classificator_name}_Name, ";
    $s .= "${classificator_name}_Priority FROM Classificator_${classificator_name}";
    $s .= " ORDER BY ";

    $SortType = $SortDirection = 0;
    if ($sort_type !== NULL && $sort_direction !== NULL)
    {
        $SortType = $sort_type;
        $SortDirection = $sort_direction;
    }
    else
    {
        $res = $db->get_row($k, ARRAY_N);
        if ($db->num_rows != 0)
        {
            $row = $res;
            $SortType = $row[0];
            $SortDirection = $row[1];
        }
    }

    switch ($SortType)
    {
        case 1:
            $s .= "${classificator_name}_Name";
            break;
        case 2:
            $s .= "${classificator_name}_Priority";
            break;
        default:
            $s .= "${classificator_name}_ID";
    }

    if ($SortDirection == 1) $s .= " DESC";

    $res = $db->get_results($s, ARRAY_A);

	if (!$res)
		return "<span style='color:red;'>Error: Incorrect Classificator Name (".$classificator_name.") in function nc_list_select().</span><br>";

    if ($db->num_rows != 0)
    {
		if ($template_prefix != NULL)
		{
			eval("\$result .= \"$template_prefix\";");
		}
		else {
			$result .= ($field_name != NULL) ? "<select name='f_${field_name}'>\r\n" : "<select>\r\n";
		}

		if (!$field->NotNull && !$template_any)
			$result .= "<option value=\"\">".NETCAT_MODERATION_LISTS_CHOOSE."</option>\r\n";

		if (!$field->NotNull && $template_any)
			eval("\$result .= \"$template_any\";");

		if ($template_object != NULL)
        {
            foreach ($res as $data)
            {
				$value_id=$data[$classificator_name."_ID"];
				if ($current_value !== NULL)
					$value_selected .= ($current_value == $data[$classificator_name."_ID"]) ? " selected" : "";
				$value_name=$data[$classificator_name."_Name"];
                eval("\$result .= \"$template_object\";");
            }
        }
		else {
            foreach ($res as $row )
            {
                $result .= "<option value='" . $row[$classificator_name."_ID"] . "'";
                if ($current_value !== NULL) $result .= ($current_value == $row[$classificator_name."_ID"]) ? " selected" : "";
                $result .= ">" . $row[$classificator_name."_Name"] . "</option>\r\n";
            }
		}

		if ($template_suffix != NULL)
		{
			$result .= $template_suffix;
		}
		else {
			$result .= "</select>";
		}

    }

    return $result;
}

//        
function nc_file_field($field_name, $style = NULL)
{
	global $db, $classID, $user_table_mode, $action, $message;
	global $sub,$cc,$DOMAIN_NAME,$HTTP_FILES_PATH;
	$result="";

	if (!in_array($field_name, $GLOBALS["fld"]))
	     { trigger_error("Incorrect field name ($field_name)", E_USER_WARNING); }

	if (!$style) $style="size='50'";

	$result .="<input name='f_".$field_name."' ".$style." type='file'>\n";

	if ($GLOBALS["f_{$field_name}_old"] && $action=="change" && $message)
	{
		$result .="<input type='hidden' name='f_".$field_name."_old' value='".$GLOBALS["f_{$field_name}_old"]."'><br>\n";
		$result .=NETCAT_MODERATION_FILES_UPLOADED;
		$result .=": <a target='_blank' href='http://".$DOMAIN_NAME.$GLOBALS["f_{$field_name}"];
		$result .="'>".$GLOBALS["f_{$field_name}_name"]."</a> (".$GLOBALS["f_{$field_name}_size"]." ".TOOLS_DUMP_INC_BYTE.")";

		$tmp_array = array_flip($GLOBALS["fld"]);
		$field_index = $tmp_array[$field_name];
		$field_id = $GLOBALS["fldID"][$field_index];

		$result .=" <input id='k$field_id' type='checkbox' name='f_KILL".$field_id."' value='1'> <label for='k$field_id'>".NETCAT_MODERATION_FILES_DELETE."</label>";
	}

	return $result;
}


#   URL
function isURL($url)
{
    if (preg_match("/^(https?|ftps?):\/\/[0-9a-z;\/\?:@&=\+,\.\-_%'\"\$~!\(\)|#\^]+$/i", $url))
    return TRUE;
    return FALSE;
}


#           
function nc_message_link ($message_id, $class_id) {
	global $db;

	$message_id = intval($message_id);
	if (!$message_id) {
		return false;
	}

	$class_id = intval($class_id);
	if (!$class_id) {
		return false;
	}

	$sql = "SELECT
				CONCAT(sub.Hidden_URL, IF(m.Keyword <> '', m.Keyword, CONCAT(cc.EnglishName, '_', m.Message_ID)), '.html') AS MessagePath
			FROM
				Message{$class_id} AS m
			LEFT JOIN
				Subdivision AS sub
				ON m.Subdivision_ID = sub.Subdivision_ID
			LEFT JOIN
				Sub_Class AS cc
				ON sub.Subdivision_ID = cc.Subdivision_ID
			WHERE
				m.Message_ID = {$message_id}";

	$path = @listQuery($sql, "\$data[MessagePath]");

	if (!$path) {
		return false;
	}

	return $path;
}


/**
  *       $field_name_or_id  $message_id   $class_id
  *
  * @param mixed string or int id /  
  * @param int id 
  * @param mixed string or int   ID 
  * @param string      (optional).
  *    "h_"         
  * @return string   
  */

function nc_file_path($class_id, $message_id, $field_name_or_id, $file_name_prefix="")
{
   static $file_field_info;
   global $db;

   $system_tables = array('', 'Catalogue', 'Subdivision', 'User', 'Template');

   if ($class_id && is_numeric($class_id))
   {
      // query to Message and Filetable
      $message_table = "Message$class_id";
      $ft_id_field = "Message_ID";

      // 'Field' query parts
      $query_where = "Class_ID=$class_id";
   }
   elseif ($class_id && in_array($class_id, $system_tables))
   {
      // query to
      $message_table = $class_id;
      $ft_id_field = "{$class_id}_ID";

      // 'Field' query parts
      $tmp_array = array_flip($system_tables);
      $query_where = "Class_ID=0 AND System_Table_ID = $tmp_array[$class_id]";
   }
   else
   {
      trigger_error("nc_file_path: wrong class ID ('$class_id')", E_USER_WARNING);
      return;
   }

   $message_id = (int)$message_id; if (!$message_id) return;

   if (!$file_field_info[$class_id])
   {
      $res = $db->get_results("SELECT Field_ID, Field_Name
                                 FROM Field
                                WHERE $query_where
                                  AND TypeOfData_ID=6", ARRAY_A);
      foreach ((array)$res as $row)
      {
         $file_field_info[$class_id][$row['Field_Name']] = $row['Field_ID'];
      }
   }

   // get correct field_name and field_id
   if (!$file_field_info[$class_id][$field_name_or_id] &&
       is_numeric($field_name_or_id) &&
       in_array($field_name_or_id, $file_field_info[$class_id]))
   // i.e. Field_ID supplied
   {
      $field_id = $field_name_or_id;
      $tmp_array = array_flip($file_field_info[$class_id]);
      $field_name = $tmp_array[$field_id];
   }
   elseif ($file_field_info[$class_id][$field_name_or_id]) // Field_Name
   {
      $field_name = $field_name_or_id;
      $field_id = $file_field_info[$class_id][$field_name];
   }
   else // it doesn't seems like name nor id
   {
      trigger_error("nc_file_path: wrong field name or ID ('$field_name_or_id')", E_USER_WARNING);
      return;
   }

   // query database
   $res = $db->get_row("SELECT m.`$field_name`  as  old_name,
                               ft.File_Path     as  new_path,
                               ft.Virt_Name     as  new_name
                          FROM $message_table as m
                               LEFT JOIN Filetable as ft
                                      ON (
                                            m.$ft_id_field = ft.Message_ID AND
                                            ft.Field_ID = $field_id
                                         )
                         WHERE m.$ft_id_field = $message_id", ARRAY_A);

   if ($res["old_name"]) // there is a file!
   {
      global $HTTP_FILES_PATH;

      // new style storage
      if ($res["new_name"])
            return rtrim($HTTP_FILES_PATH, "/") . $res['new_path'] . $file_name_prefix . $res['new_name'];

      // old style storage
      preg_match("/^[^:]+(\.[^:]+):/", $res["old_name"], $regs);
      $ext = $regs[1];
      return "$HTTP_FILES_PATH{$field_id}_{$message_id}{$ext}";
   }

   return; // sorry, nothing found
}


function dump($var)
{
   print "<hr><xmp>".print_r($var,1)."</xmp><hr>";
}

?>