<?
/* $Id: s_extract.inc.php,v 1.16 2006/08/21 14:45:46 kx Exp $ */

@include_once("../vars.inc.php");

if ($use_gzip_compression) { ob_start("ob_gzhandler");} else { ob_start(); }

$client_url = urldecode("http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']);
$parsed_url = parse_url($client_url);
if ($parsed_url['query']) parse_str($parsed_url['query'], $_GET);


$netcat_variables = array(
 // superglobals inside superglobals are not allowed
"_SERVER", "_ENV", "_FILES", "_GET", "_POST", "_COOKIE",
 // netcat configuration variables
"AJAX_SAVER",
"ADMIN_AUTHTIME",
"ADMIN_AUTHTYPE",
"ADMIN_FOLDER",
"ADMIN_LANGUAGE",
"AUTHORIZATION_TYPE",
"AUTHORIZE_BY",
"AUTH_USER_GROUP",
"AUTH_USER_ID",
"CHARSET",
"DEVELOPER_NAME",
"DEVELOPER_URL",
"DIRCHMOD",
"DOCUMENT_ROOT",
"DOC_DOMAIN",
"DOMAIN_NAME",
"EDIT_DOMAIN",
"FILECHMOD",
"FILES_FOLDER",
"HTTP_FILES_PATH",
"HTTP_HOST",
"HTTP_ROOT_PATH",
"INCLUDE_FOLDER",
"MODULE_FOLDER",
"MYSQL_CHARSET",
"MYSQL_DB_NAME",
"MYSQL_HOST",
"MYSQL_PASSWORD",
"MYSQL_USER",
"NETCAT_ROOT_FOLDER",
"PHP_TYPE",
"REDIRECT_STATUS",
"ROOT_FOLDER",
"SHOW_MYSQL_ERRORS",
"SOURCE_CHARSET",
"TMP_FOLDER");

// it's faster than using $_REQUEST, even without check whether all variables present in $_REQUEST or not
$_NETCAT_INPUT = array_merge($_GET, $_POST, $_COOKIE, $_FILES, $_ENV, $_SERVER);

// clean up input
foreach ($netcat_variables as $var)
{
  unset($_NETCAT_INPUT[$var]);
}


// XMLHttpRequest Call: it's in UTF
if ($_POST["NC_HTTP_REQUEST"])
{
   require_once("utf8/utf8.php");
   function array_utf2win($input)
   {
      if (!is_array($input)) return win($input);
      $output = array();

      foreach ($input as $k=>$v)
      {
         $output[win($k)] = is_array($v) ? array_utf2win($v) : win($v);
      }

      return $output;
   }

   $_NETCAT_INPUT = array_utf2win($_NETCAT_INPUT);
}

if (!get_magic_quotes_gpc()) // ESCAPE THE INPUT!
{
   function recursive_add_slashes($input)
   {
      if (!is_array($input)) return addslashes($input);
      $output = array();

      foreach ($input as $k=>$v)
      {
         $output[$k] = is_array($v) ? recursive_add_slashes($v) : addslashes($v);
      }

      return $output;
   }

   $_NETCAT_INPUT = recursive_add_slashes($_NETCAT_INPUT);
}

extract($_NETCAT_INPUT);
$_NETCAT_INPUT = null; // free memory up

$_cache = array();

?>