<?php
/* $Id: s_list.inc.php,v 1.16 2006/08/21 14:45:46 kx Exp $ */

function s_list_class($sub, $cc, $query_string = "", $show_in_admin_mode = FALSE)
{
	parse_str ($query_string, $LIST_VARS);
	unset($LIST_VARS['admin_mode']);
	unset($LIST_VARS['user_table_mode']);
	unset($LIST_VARS['catalogue']);
	unset($LIST_VARS['sub']);
	unset($LIST_VARS['cc']);
	unset($LIST_VARS['ignore_sub']);
	unset($LIST_VARS['cond_sub']);
	unset($LIST_VARS['ignore_cc']);
	unset($LIST_VARS['cond_cc']);
	unset($LIST_VARS['ignore_user']);
	unset($LIST_VARS['cond_user']);
	unset($LIST_VARS['ignore_parent']);
	unset($LIST_VARS['cond_parent']);
	unset($LIST_VARS['ignore_check']);
	unset($LIST_VARS['cond_check']);
	unset($LIST_VARS['cond_search']);
	unset($LIST_VARS['cond_mod']);
	unset($LIST_VARS['cond_date']);
	unset($LIST_VARS['distinct']);
	unset($LIST_VARS['distinctrow']);
	unset($LIST_VARS['query_select']);
	unset($LIST_VARS['result_vars']);
	unset($LIST_VARS['cond_select']);
	unset($LIST_VARS['query_join']);
	unset($LIST_VARS['cond_join']);
	unset($LIST_VARS['query_from']);
	unset($LIST_VARS['cond_from']);
	unset($LIST_VARS['query_where']);
	unset($LIST_VARS['cond_where']);
	unset($LIST_VARS['query_order']);
	unset($LIST_VARS['query_group']);
	unset($LIST_VARS['cond_group']);
	extract ($LIST_VARS);


	global $db;
	global $MODULE_VARS;
	global $admin_mode, $admin_url_prefix;
	global $current_catalogue, $current_sub, $current_cc;
	global $AUTHORIZE_BY, $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $HTTP_FILES_PATH, $DOCUMENT_ROOT;

	$catalogue+=0;
	$sub+=0;
	$cc+=0;
	$template+=0;

	if (!$sub || !$cc) return NULL;
	if ($cc != $current_cc['Sub_Class_ID'] && ($admin_mode && !$show_in_admin_mode)) return NULL;
	if (!$isMainContent && ($admin_mode && !$show_in_admin_mode)) return NULL;
	$cc_env = ListClassVars($cc, $user_table_mode);

	if ($cc_env['Read_Access_ID']>1 && !$AUTH_USER_ID) return NULL;
	if ($AUTH_USER_ID && $cc_env['Read_Access_ID']>2) {
		$HasRights = CheckUserRights($cc, 'read', 1);
		if (!$HasRights) return NULL;
	}

	if ($cc_env['System_Table_ID']) $user_table_mode = true;

	$allowTags = $cc_env['AllowTags'];
	$NL2BR = $cc_env['NL2BR'];
	$catalogue = $cc_env['Catalogue_ID'];
	$classSettings = $cc_env['Settings'];
	$intQueryStr = '?';

	$ignore_user = true;
	if ($classSettings) eval($classSettings);

	$curPos += 0;
	$recNum += 0;

	$maxRows = $cc_env['RecordsPerPage'];
	$sortBy = $cc_env['SortBy'];
	$classID = $cc_env['Class_ID'];
	$userTableID = $cc_env['System_Table_ID'];

	if (!$sortBy)
	{
		if ($user_table_mode)
		$sort_by = 'a.'.$AUTHORIZE_BY.', a.LastUpdated DESC';
		else
		$sort_by = 'a.Priority DESC, a.LastUpdated DESC';
	}
	else
	$sort_by = $sortBy;

	if ($admin_mode) {
		$subLink = $admin_url_prefix.'?catalogue='.$catalogue.'&sub='.$sub;
		$ccLink = $subLink.'&cc='.$cc;
		$intQueryStr = $ccLink;
	}

	//,    ,     
	if (!$classID) return NULL;

	$res = $db->get_results('SELECT Field_ID, Field_Name, TypeOfData_ID, Format'.(!$user_table_mode?', DoSearch':', 1 AS DoSearch').' FROM Field WHERE '.($user_table_mode?'System_Table_ID='.$userTableID:'Class_ID='.$classID).' ORDER BY Priority', ARRAY_A);
	$field_count = $db->num_rows;


	$field_names = '';
	$field_vars = '';
	$convert2txt = '';

	for($i=0; $i<$field_count; $i++) {
		$field_array = $res[$i];

		$field_name_query = "";
		$field_var = "";

		$field_name[$i] = $field_array['Field_Name'];
		$field_search[$i] = $field_array['DoSearch'];
		$field_type[$i] = $field_array['TypeOfData_ID'];

   	global $_cache;

		switch ($field_type[$i]) {
			case 4: {
				$joins .= " LEFT JOIN Classificator_".$field_array["Format"]." AS tbl".$field_array["Field_ID"]." ON a.".$field_array["Field_Name"]."=tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID ";

				$field_name_query = "tbl".$field_array["Field_ID"].".".$field_array["Format"]."_Name as tbl".$field_array["Field_ID"]."name";
				$field_name_query .= ", tbl".$field_array["Field_ID"].".".$field_array["Format"]."_ID as tbl".$field_array["Field_ID"]."id";

				$field_var = "\$f_".$field_array["Field_Name"];
				$field_var .= ", \$f_".$field_array["Field_Name"]."_id";
			} break;
			case 6: {
				// used in s_list_message()
            $_cache["file_fields"][$classID][$field_array['Field_ID']] = $field_array['Field_Name'];

				$field_name_query = "IF(a.".$field_array["Field_Name"]."<>'',CONCAT('".$HTTP_FILES_PATH.$field_array["Field_ID"]."_',".($user_table_mode?"a.User_ID":"a.Message_ID").",RIGHT(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1), LOCATE('.',REVERSE(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1))))),'')";
				$field_var = "\$f_".$field_array["Field_Name"];

				$field_name_query .= ", SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',1)";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_name";

				$field_name_query .= ", SUBSTRING_INDEX(SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',-2),':',1)";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_type";

				$field_name_query .= ", SUBSTRING_INDEX(a.".$field_array["Field_Name"].",':',-1)";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_size";
			} break;
			case 8: {
				$field_name_query = "a.".$field_array["Field_Name"];
				$field_var = "\$f_".$field_array["Field_Name"];

				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%Y')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_year";
				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%m')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_month";
				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%d')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_day";

				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%H')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_hours";
				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%i')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_minutes";
				$field_name_query .= ", DATE_FORMAT(a.".$field_array["Field_Name"].",'%s')";
				$field_var .= ", \$f_".$field_array["Field_Name"]."_seconds";

				if ($field_array['Format']=='event') $date_field = $field_array['Field_Name'];
			} break;
			default: {
				$field_name_query = "a.".$field_array['Field_Name'];
				$field_var = "\$f_".$field_array['Field_Name'];
			} break;
		}
		if ($field_name_query && $field_var) {
			$field_names .= $field_name_query.',';
			$field_vars .= $field_var.',';
		}
		if (!$allowTags && ($field_type[$i]==3 || $field_type[$i]==1)) $convert2txt .= "\$f_".$field_name[$i]." = htmlspecialchars(\$f_".$field_name[$i].");";
		if ($NL2BR && ($field_type[$i]==3 || $field_type[$i]==1)) $convert2txt .= "\$f_".$field_name[$i]." = nl2br(\$f_".$field_name[$i].");";
	}

	$fullSearchParams = getSearchParams($field_name,$field_type,$field_search,$srchPat);

	$fullSearchStr = $fullSearchParams['query'];
	$fullSearchURL = $fullSearchParams['link'];
	$parent_message+=0;

	if (!$ignore_catalogue)
	{
		$cond_catalogue = " AND sub.Catalogue_ID='".$catalogue."'";
		$cond_catalogue_add = " AND a.Subdivision_ID=sub.Subdivision_ID";
		$cond_catalogue_addtable = ", Subdivision as sub";
	}

	if (!$ignore_sub)			$cond_sub = " AND a.Subdivision_ID='".$sub."'";
	if (!$ignore_cc)			$cond_cc = " AND a.Sub_Class_ID='".$cc."'";
	if (!$ignore_user)			$cond_user = " AND a.User_ID='".$AUTH_USER_ID."'";
	if (!$ignore_parent)			$cond_parent = " AND a.Parent_Message_ID='".$parent_message."'";
	if (!$cond_search)			$cond_search = $fullSearchStr;
	if (!$admin_mode && !$ignore_check)	$cond_mod = ' AND a.Checked=1';
	if ($date)				$cond_date = " AND a.".$date_field." LIKE '$date%'";

	if ($distinct)		$cond_distinct = 'DISTINCT';
	if ($distinctrow)	$cond_distinct = 'DISTINCTROW';
	if ($query_select && $result_vars)
	$cond_select = ", ".$query_select;
	if ($query_join)	$cond_join = $query_join;
	if ($query_from)	$cond_from = ','.$query_from;
	if ($query_where)	$cond_where = ' AND '.$query_where;
	if ($query_order)	$sort_by = $query_order;
	if ($query_group)	$cond_group = ' GROUP BY '.$query_group;

	if ($user_table_mode) {
		$cond_sub = '';
		$cond_cc = '';
		$cond_catalogue_add = '';
		$cond_catalogue = '';
		$cond_catalogue_addtable = '';
	}
	$intQueryStr .= $fullSearchURL;


        if (!$recNum) { $recNum = $maxRows; }
                 else { $maxRows = $recNum; }

	if (!$user_table_mode)
	$table_extra = 'sub.Hidden_URL, cc.EnglishName, a.Message_ID, a.User_ID, a.IP, a.UserAgent, a.LastUser_ID, a.LastIP, a.LastUserAgent, a.Priority, cc.Sub_Class_ID, sub.Subdivision_ID';
	else
	$table_extra = 'a.User_ID, a.PermissionGroup_ID';

	$table_extra .= ', a.Checked, a.Created, a.LastUpdated, a.Keyword';
	$message_select = 'SELECT SQL_CALC_FOUND_ROWS '.$cond_distinct.' '.$field_names.$table_extra.$cond_select.' FROM ('.($user_table_mode?'User':'Message'.$classID).' AS a '.$cond_from.')'.$joins.(!$user_table_mode?' LEFT JOIN Subdivision AS sub ON sub.Subdivision_ID=a.Subdivision_ID LEFT JOIN Sub_Class AS cc ON cc.Sub_Class_ID=a.Sub_Class_ID':'').' '.$query_join.' WHERE 1 '.(!$user_table_mode?(!$ignore_parent?" AND a.Parent_Message_ID=\".\$parent_message.\"":""):"")." ".$cond_where.$cond_catalogue.$cond_sub.$cond_cc.$cond_user.$cond_mod.$cond_search.$cond_date.$cond_group.' ORDER BY '.$sort_by.' LIMIT '.$curPos.','.$maxRows;

	$addLink = $cc_env['Hidden_URL'].'add_'.$cc_env['EnglishName'].'.html';
	$subscribeLink = $cc_env['Hidden_URL'].'subscribe_'.$cc_env['EnglishName'].'.html';
	$searchLink = $cc_env['Hidden_URL'].'search_'.$cc_env['EnglishName'].'.html';

	$cc_env['LocalQuery'] = $intQueryStr;
	$cc_env['curPos'] = $curPos;
	$cc_env['dateField'] = $date_field;
	$cc_env['recNum'] = $recNum;
	$cc_env['maxRows'] = $maxRows;
	$cc_env['addLink'] = $addLink;
	$cc_env['subscribeLink'] = $subscribeLink;
	$cc_env['searchLink'] = $searchLink;
	$cc_env['fieldCount'] = $field_count;
	$cc_env['convert2txt'] = $convert2txt;

	$parent_message += 0;
	$parent_message_tree[0] = $parent_message;

	$result .= s_list_message($parent_message, $cc_env, $message_select, $field_vars, $query_string, $parent_message_tree);
	return $result;
}

function s_list_message($parent_message, $cc_env, $message_select, $field_vars, $query_string, $parent_message_tree)
{
	parse_str($query_string, $LIST_VARS);
	unset($LIST_VARS['admin_mode']);
	unset($LIST_VARS['user_table_mode']);
	unset($LIST_VARS['catalogue']);
	unset($LIST_VARS['sub']);
	unset($LIST_VARS['cc']);
	unset($LIST_VARS['parent_message']);
	unset($LIST_VARS['cc_env']);
	unset($LIST_VARS['message_select']);
	unset($LIST_VARS['field_vars']);
	unset($LIST_VARS['parent_message_tree']);
	extract($LIST_VARS);

	global $db,$system_env;
	global $MODULE_VARS, $DOMAIN_NAME;
	global $current_catalogue, $current_sub, $current_cc;
	global $admin_mode, $admin_url_prefix;
	global $AUTHORIZE_BY, $AUTH_USER_ID, $AUTH_USER_GROUP;
	global $DOCUMENT_ROOT, $FILES_FOLDER, $HTTP_FILES_PATH;

	$catalogue = $cc_env['Catalogue_ID'];
	$sub = $cc_env['Subdivision_ID'];
	$cc = $cc_env['Sub_Class_ID'];
	$classID = $cc_env['Class_ID'];

	$maxRows = $cc_env['maxRows'];
        $curPos = $cc_env['curPos'];
	$recNum = $cc_env['recNum'];

	$date_field = $cc_env['dateField'];
	$addLink = $cc_env['addLink'];
	$changeLink = $cc_env['changeLink'];
	$subscribeLink = $cc_env['subscribeLink'];
	$searchLink = $cc_env['searchLink'];

	$subLink = $cc_env['Hidden_URL'];
	$subHost = "http://".($cc_env['Hidden_Host']?(strchr($cc_env['Hidden_Host'],'.')?$cc_env['Hidden_Host']:$cc_env['Hidden_Host'].'.'.$DOMAIN_NAME):$DOMAIN_NAME);
	$cc_keyword = $cc_env['EnglishName'];
	$ccLink = $sub_url.$cc_keyword.'.html';

	$parent_message+=0;

	if ($cc_env['Settings']) eval($cc_env['Settings']);

	eval("\$searchForm = \"".$cc_env["FullSearchTemplate"]."\";");
	eval("\$addForm = \"".$cc_env["AddTemplate"]."\";");

	eval ("\$res = \$db->get_results(\"".$message_select."\", ARRAY_N);");
	$rowCount = $db->num_rows; //    
	$totRows = $db->get_var("SELECT FOUND_ROWS()"); //  

	$begRow = $curPos+1;
	if ($curPos >= $maxRows)
	{
	   $prevLink = $cc_env['LocalQuery'].(strlen($cc_env['LocalQuery']) > 1 ? "&" : "")."curPos=".($curPos-$maxRows);
        }

	$endRow = $curPos + $maxRows;
	if ($endRow < $totRows)
	   $nextLink = $cc_env['LocalQuery'].(strlen($cc_env['LocalQuery']) > 1 ? "&" : "")."curPos=".$endRow;
	else
 	   $endRow = $totRows;

	$cc_env['begRow']   = $begRow;
	$cc_env['endRow']   = $endRow;
	$cc_env['totRows']  = $totRows;
	$cc_env['prevLink'] = $prevLink;
	$cc_env['nextLink'] = $nextLink;

	if ($cc_env['System_Table_ID']) $user_table_mode = true;

	if ($user_table_mode)
	$extra_vars = "\$f_RowID, \$f_UserGroup, ";
	else
	$extra_vars = "\$subLink, \$cc_keyword, \$f_RowID, \$f_UserID, \$f_IP, \$f_UserAgent, \$f_LastUserID, \$f_LastIP, \$f_LastUserAgent, \$f_Priority, \$f_Sub_Class_ID, \$f_Subdivision_ID, ";

	$fetch_row = "list(".$field_vars.$extra_vars."\$f_Checked, \$f_Created, \$f_LastUpdated, \$f_Keyword".($result_vars?", ".$result_vars:"").") = \$res[\$f_RowNum];";

	if ($admin_mode)
	{
		//   
		$f_AdminCommon_cc = $cc;

		//   
		$f_AdminCommon_cc_name = $cc_env['Sub_Class_Name'];

		// 
		$f_AdminCommon_add = $admin_url_prefix."add.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc;

		//  
		$f_AdminCommon_delete_all = $admin_url_prefix."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&delete=1";

		//   CSV
		$f_AdminCommon_export_csv = $admin_url_prefix."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&export=1";

		//   CSV
		$f_AdminCommon_import_csv = $admin_url_prefix."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&import=1";

		//   XML
		$f_AdminCommon_export_xml = $admin_url_prefix."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&export=1";

		//   XML
		$f_AdminCommon_import_xml = $admin_url_prefix."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&import=2";

		if ($system_env['AdminButtonsType'])
		{
			eval("\$f_AdminCommon = \"".$system_env['AdminCommon']."\";");
		}
		else
		{
			$f_AdminCommon = "<div style='float:right;background-color:#FFFFFF;border: 1px solid #ccc;color:#000;padding:8px;width:350px;margin-left:auto;'>
			<div style='float:left;width:70%;'><font style='font-size:0.95em;'>".NETCAT_MODERATION_CLASSID.": <b>".$f_AdminCommon_cc."</b></font><br><font style='font-size:0.85em;'>(".$f_AdminCommon_cc_name.")</font></div>
			<div style='float:right;width:30%;' align=right valign=middle wrap=off><a href='".$f_AdminCommon_add."'><img src=/netcat/admin/images/add.gif alt='".CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_ADD."' title='".CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWMENU_ADD."' border=0 style='margin: 3px 4px 3px 4px;'></a><a href='".$f_AdminCommon_delete_all."'><img src=/netcat/admin/images/kill.gif alt='".NETCAT_MODERATION_REMALL."' title='".NETCAT_MODERATION_REMALL."' border=0 style='margin: 3px 4px 3px 4px;'></a></div>
			</div><div style='clear:both;'></div>";
		}
	}

	if (!$cc_env['FormPrefix']) $result .= $f_AdminCommon;

	eval("\$result .= \"".$cc_env["FormPrefix"]."\";");

	/***/
   global $_cache;
   for($f_RowNum=0; $f_RowNum<$rowCount; $f_RowNum++)
	{
		eval($fetch_row);
		eval($cc_env['convert2txt']);
		if ($cc_env['Hidden_Host'])
		{
			$subHost = "http://".($cc_env['Hidden_Host']?(strchr($cc_env['Hidden_Host'],'.')?$cc_env['Hidden_Host']:$cc_env['Hidden_Host'].'.'.$DOMAIN_NAME):$DOMAIN_NAME);
		}

		foreach ((array)$_cache["file_fields"][$classID] as $field_id => $field_name)
		{
			if (!${"f_$field_name"}) // [WEAK CHAIN!] apparently we don't have a file
			{
			   ${"f_{$field_name}_url"} = NULL;
                           continue;
			}

			$filetable_path = ($user_table_mode ? "u" : "$f_Subdivision_ID/$f_Sub_Class_ID");
			$q = $db->get_row("SELECT Virt_Name, Real_Name
			                     FROM Filetable
			                    WHERE Field_ID = '$field_id'
			                      AND Message_ID = '$f_RowID'
			                      AND File_Path = '/$filetable_path/'", ARRAY_N);
			list($Virt_Name, $Real_Name) = $q;

			if ($Virt_Name)
			{
				${"f_$field_name"} = $HTTP_FILES_PATH."$filetable_path/h_$Virt_Name";
				${"f_{$field_name}_url"} = $HTTP_FILES_PATH."$filetable_path/$Virt_Name";
			}
			else // old-style filesystem
			{
                            ${"f_{$field_name}_url"} = ${"f_$field_name"};
			}
		}

		$f_Created_year = substr($f_Created,0,4);
		$f_Created_month = substr($f_Created,5,2);
		$f_Created_day = substr($f_Created,8,2);
		$f_Created_hours = substr($f_Created,11,2);
		$f_Created_minutes = substr($f_Created,14,2);
		$f_Created_seconds = substr($f_Created,17,2);

		$f_LastUpdated_year = substr($f_LastUpdated,0,4);
		$f_LastUpdated_month = substr($f_LastUpdated,4,2);
		$f_LastUpdated_day = substr($f_LastUpdated,6,2);
		$f_LastUpdated_hours = substr($f_LastUpdated,8,2);
		$f_LastUpdated_minutes = substr($f_LastUpdated,10,2);
		$f_LastUpdated_seconds = substr($f_LastUpdated,12,2);

		if ($date_field && !$admin_mode)
		eval("\$dateLink = \$f_".$date_field."_year.\"/\".\$f_".$date_field."_month.\"/\".\$f_".$date_field."_day.\"/\";");
		elseif ($date_field && $admin_mode)
		eval("\$dateLink = \"&date=\".\$f_".$date_field."_year.\"-\".\$f_".$date_field."_month.\"-\".\$f_".$date_field."_day;");

		$fullLink = $subLink.($f_Keyword?$f_Keyword:$cc_keyword."_".$f_RowID).".html";
		$fullDateLink = $subLink.$dateLink.($f_Keyword?$f_Keyword:$cc_keyword."_".$f_RowID).".html";

		if ($catalogue != $current_catalogue['Catalogue_ID']) {
			$fullLink = $subHost.$fullLink;
			$fullDateLink = $subHost.$fullDateLink;
		}

		if ($admin_mode) {
			$fullLink = $admin_url_prefix."full.php?catalogue=$catalogue&sub=$sub&cc=$cc&message=".$f_RowID;
			$fullDateLink = $fullLink.$dateLink;

			// ID   
			$f_AdminButtons_id = $f_RowID;

			//  
			$f_AdminButtons_priority = $f_Priority;

			// ID  
			$f_AdminButtons_user_add = $f_UserID;

			// ID  
			$f_AdminButtons_user_change = ($f_LastUserID?$f_LastUserID:'');

			// 
			$f_AdminButtons_change = $HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&curPos=$curPos";

			// 
			$f_AdminButtons_delete = $HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&delete=1&curPos=$curPos";

			// -
			$f_AdminButtons_check = ($f_Checked?$any_url_prefix.$HTTP_ROOT_PATH."message.php?sub=$sub&cc=$cc&classID=$classID&message=$f_RowID&checked=1&posting=1&curPos=$curPos".($admin_mode?"&admin_mode=1":""):$admin_url_prefix.$HTTP_ROOT_PATH."message.php?sub=$sub&cc=$cc&classID=$classID&message=$f_RowID&checked=2&posting=1&curPos=$curPos".($admin_mode?"&admin_mode=1":""));


			if ($system_env['AdminButtonsType'])
			{
				eval("\$f_AdminButtons = \"".$system_env['AdminButtons']."\";");

			}
			else
			{
				$f_AdminButtons = "<div style='float:left;background-color:#FFFFFF;border: 1px solid #ccc;color:#000;padding:8px;width:350px;margin-right:auto;'>
				<div style='float:left;width:70%;'><font style='font-size:0.95em;'>".sprintf(NETCAT_MODERATION_TURNTID, $f_AdminButtons_id, $f_AdminButtons_priority)."</font><br><font style='font-size:0.85em;'>".NETCAT_MODERATION_ADDEDON.": ".$f_AdminButtons_user_add."".($f_AdminButtons_user_change?'<br>'.NETCAT_MODERATION_CHANGED.': '.$f_AdminButtons_user_change:'')."</font></div>
				<div style='float:right;width:30%;' align=right valign=middle wrap=off><a href='".$f_AdminButtons_change."'><img src=/netcat/admin/images/edit.gif alt='".NETCAT_MODERATION_CHANGE."' title='".NETCAT_MODERATION_CHANGE."' border=0 style='margin: 3px 4px 3px 4px;'></a><a href='".$f_AdminButtons_delete."'><img src=/netcat/admin/images/kill.gif alt='".NETCAT_MODERATION_DELETE."' title='".NETCAT_MODERATION_DELETE."' border=0 style='margin: 3px 4px 3px 4px;'></a>".($f_Checked?"<a href=".$f_AdminButtons_check."><img src=/netcat/admin/images/check.gif alt='".NETCAT_MODERATION_TURNTOON."' title='".NETCAT_MODERATION_TURNTOON."' border=0 style='margin: 3px 4px 3px 4px;'></a>":"<a href=".$f_AdminButtons_check."><img src=/netcat/admin/images/check_g.gif alt='".NETCAT_MODERATION_TURNTOOFF."' title='".NETCAT_MODERATION_TURNTOOFF."' border=0 style='margin: 3px 4px 3px 4px;'></a>")."</div>
				</div><div style='clear:both;'></div><br>";
			}

			if ($user_table_mode) $f_AdminButtons = "";
		}
		eval("\$result .= \"".$cc_env["RecordTemplate"]."\";");

		$parent_message_tree[] = $f_RowID;
		if ($children) $result .= s_list_message($f_RowID, $cc_env, $message_select, $field_vars, $query_string, $parent_message_tree);
	}

	eval("\$result .= \"".$cc_env["FormSuffix"]."\";");

	return $result;
}


function showSearchForm ($fldName, $fldType, $fldDoSearch, $fldFmt) {
	global $systemTableID, $db;

	$j = 0;
	for($i=0; $i<count($fldName); $i++) {
		$fldNameTempl = "<b>".$fldName[$i]."</b>";

		if (!$fldDoSearch[$i]) continue;

		switch($fldType[$i]) {
			case 1:	// Char
			$result .= $fldNameTempl.":<br><input name=srchPat[".$j."] type=text size=50 maxlength=255><br>";
			$j++;
			break;

			case 3:	// Text
			$result .= $fldNameTempl.":<br><input name=srchPat[".$j."] type=text size=50 maxlength=255><br>";
			$j++;
			break;

			case 2:	// Int
			$result .= $fldNameTempl.NETCAT_MODERATION_MOD_FROM."<input name=srchPat[".$j."] type=text size=10 maxlength=16>";
			$j++;
			$result .= NETCAT_MODERATION_MOD_DON."<input name=srchPat[".$j."] type=text size=10 maxlength=16><br>";
			$j++;
			break;

			case 7:	// Float
			$result .= $fldNameTempl.NETCAT_MODERATION_MOD_FROM."<input name=srchPat[".$j."] type=text size=10 maxlength=16>";
			$j++;
			$result .= NETCAT_MODERATION_MOD_DON."<input name=srchPat[".$j."] type=text size=10 maxlength=16><br>";
			$j++;
			break;

			case 4:	// List
			$result .= $fldNameTempl.":<br><select name=srchPat[".$j."] size=1>";
			$result .= "<option value=''>".NETCAT_MODERATION_MODA;

			$SortType = $SortDirection = 0;
			$res = $db->get_row("SELECT Sort_Type, Sort_Direction FROM Classificator WHERE Table_Name='".$fldFmt[$i]."'", ARRAY_N);
			if ($db->num_rows != 0)
			{
				$row = $res;
				$SortType = $row[0];
				$SortDirection = $row[1];
			}

			$s = "SELECT * FROM Classificator_$fldFmt[$i] ORDER BY ";
			switch ($SortType)
			{
				case 1: $s .= $fldFmt[$i]."_Name"; break;
				case 2: $s .= $fldFmt[$i]."_Priority"; break;
				default: $s .= $fldFmt[$i]."_ID";
			}

			if ($SortDirection == 1) $s .= " DESC";

			$lstRes = $db->get_results($s, ARRAY_N);
			foreach  ($lstRes as $q) {
				list($lstID, $lstName) = $q;
				$result .= "<option value='$lstID'>$lstName";
			}
			$result .= '</select><br>';
			$j++;
			break;

			case 5: // Bool
			$result .= $fldNameTempl.":<br>";
			$result .= "<input checked name='srchPat[{$j}]' type='radio' id='t{$j}_1' value=''> <label for='t{$j}_1'>".NETCAT_MODERATION_MOD_NOANSWER.'</label> ';
			$result .= "<input name='srchPat[{$j}]' type='radio' id='t{$j}_2' value='1'> <label for='t{$j}_2'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_OBJ_YES.'</label> ';
			$result .= "<input name='srchPat[{$j}]' type='radio' id='t{$j}_3' value='0'> <label for='t{$j}_3'>".CONTROL_CONTENT_SUBDIVISION_FUNCS_OBJ_NO.'</label>';
			$result .= "<br>";
			$j++;
			break;

			case 8:	// DateTime
			$result .= $fldNameTempl.NETCAT_MODERATION_MOD_FROM;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>-"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>-"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='4' maxlength='4'> "; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>:"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>:"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'> "; $j++;

			$result .= NETCAT_MODERATION_MOD_DON;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>-"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>-"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='4' maxlength='4'> "; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>:"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'>:"; $j++;
			$result .= "<input name='srchPat[{$j}]' type='text' size='2' maxlength='2'> "; $j++;
			$result .= '<br>';
			break;

		}
		$result .= "<br>";
	}
	if (!$j) return false;
	return $result;
}


function getSearchParams ($field_name, $field_type, $field_search, $srchPat) {
	global $db;

	for($i=0,$j=0; $i<count($field_name); $i++) {
		if ($field_search[$i] && $field_type[$i]!=6) {
			switch($field_type[$i]) {
				case 1:	// Char
				if($srchPat[$j] == "") break;
				$fullSearchStr .= " AND a.".$field_name[$i]." LIKE '%".urldecode($srchPat[$j])."%'";
				$fullSearchURL .= "&srchPat[$j]=".urldecode($srchPat[$j]);
				break;
				case 2:	// Int
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND a.".$field_name[$i].">=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND a.".$field_name[$i]."<=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				break;
				case 3:	// Text
				if($srchPat[$j] == "") break;
				$fullSearchStr .= " AND a.".$field_name[$i]." LIKE '%".urldecode($srchPat[$j])."%'";
				$fullSearchURL .= "&srchPat[$j]=".urldecode($srchPat[$j]);
				break;
				case 4: // List
				if($srchPat[$j] == "") break;
				$srchPat[$j] += 0;
				$fullSearchStr .= " AND a.".$field_name[$i]."=".$srchPat[$j];
				$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				break;
				case 5:	// Boolean
				if($srchPat[$j] == "") break;
				$srchPat[$j] += 0;
				$fullSearchStr .= " AND a.".$field_name[$i]."=".$srchPat[$j];
				$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				break;
				case 7:	// Float
				if($srchPat[$j] != "") {
					$srchPat[$j] = floatval($srchPat[$j]);
					$fullSearchStr .= " AND a.".$field_name[$i].">=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] = floatval($srchPat[$j]);
					$fullSearchStr .= " AND a.".$field_name[$i]."<=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				break;
				case 8:	// DateTime
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%d')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%m')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%Y')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%H')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%i')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%s')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%d')<=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%m')<=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%Y')<=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%H')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%i')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				$j++;
				if($srchPat[$j] != "") {
					$srchPat[$j] += 0;
					$fullSearchStr .= " AND DATE_FORMAT(a.".$field_name[$i].",'%s')>=".$srchPat[$j];
					$fullSearchURL .= "&srchPat[$j]=".$srchPat[$j];
				}
				break;
			}
			$j++;
		}
	}
	$search_params['query'] = $fullSearchStr;
	$search_params['link'] = $fullSearchURL;

	return $search_params;
}

?>