<?
/* $Id: index.php,v 1.10 2006/08/11 12:08:48 kx Exp $ */

require_once ("../../vars.inc.php");
require ("../function.inc.php");
require ("function.inc.php");
require ("../../require/s_loadenv.inc.php");
require ("../tar.inc.php");

#LoadEnv();

$main_section = "settings";
$item_id = 3;
$Delimeter = " &gt ";
$Title2 = TOOLS_MODULES;
$Title3 = "<a href=\"/netcat/admin/modules/\">".TOOLS_MODULES."</a>";
if ($ModuleID)
{
    $Title4 = GetModuleName ($ModuleID);
}

$SubdivisionID = GetModuleSubdivisionByID ($ModuleID);
$CatalogueID = (int) GetCatalogueBySubdivision ($SubdivisionID);

if ( !($perm->isSupervisor() || $perm->isGuest()) )
{
    BeginHtml ($Title2, $Title2, "");
    print $NO_RIGHTS_MESSAGE;
    EndHtml ();
    exit;
}

if (!isset($phase))
{
    $phase=1;
}

switch ($phase)
{
    case 1:
        #   
        BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/modules/");
        TitleModule ();
        break;

    case 2:
        #   
        if ( !($perm->isSupervisor() || $perm->isGuest() || $perm->isCatalogueAdmin ($CatalogueID) || $perm->isSubdivisionAdmin ($SubdivisionID) )   )
        {
            BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/modules/");
            print $NO_RIGHTS_MESSAGE;
            EndHtml ();
            exit;
        }

        BeginHtml ($Title2, $Title3.$Delimeter.$Title4, "http://".$DOC_DOMAIN.GetHelpURL ($ModuleID));
        ModuleUpdateForm ($ModuleID);

        break;

    case 3:
        #   
        BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/modules/");

        $perm->ExitIfGuest ();

        ModuleUpdateCompleted ();
        TitleModule ();

        break;

    case 4:
        #  
        BeginHtml ($Title2, $Title2, "http://".$DOC_DOMAIN."/settings/modules/");
        $perm->ExitIfGuest ();

		if (!checkPermissions("/netcat/tmp/",$DOCUMENT_ROOT))
			break;
		if (!checkPermissions("/netcat/modules/",$DOCUMENT_ROOT))
			break;

        if (!$_FILES['FilePatch']['tmp_name'])
        {
            print TOOLS_MODULES_ERR_NOTUPLOADED.".<br>\n";
            InstallationAborted ();
        }

        $PatchFile = $_FILES['FilePatch']['tmp_name'];

        if (!nc_tgz_extract($PatchFile, $TMP_FOLDER))
        {
		echo "<span style=\"color:red;\">Error while module file extracting</span>";
		break;
        }


        $InstallFile = $TMP_FOLDER."install.php";
        if (!is_readable ($InstallFile) )
        {
            print TOOLS_MODULES_ERR_CANTOPEN." install.php.<br>\n";
            InstallationAborted ();
        }
        else
        {
            require $InstallFile;
        }

        if (!CheckDeps () )
        {
            InstallationAborted ();
        }
        CheckFiles ();

        if ($SystemVersion != $VERSION_ID)
        {
            print TOOLS_MODULES_ERR_VERSION." NetCat.<br>\n";
            InstallationAborted ();
        }

        if ($SystemID == "1")
        {
            print TOOLS_MODULES_ERR_VERSION." NetCat.<br>\n";
            InstallationAborted ();
        }

        if ( IsAlreadyInstalled () )
        {
            print TOOLS_MODULES_ERR_INSTALLED.".<br>\n";
            InstallationAborted ();
        }

        if (CheckAbilityOfInstallation () == 0)
        {
            print TOOLS_MODULES_ERR_ITEMS.".<br>\n";
            InstallationAborted ();
        }

        $Install = InstallThisModule ();
        if ($Install["Success"] == 0)
        {
            print TOOLS_MODULES_ERR_DURINGINSTALL.": ".$Install["ErrorMessage"].".<br>\n";
            InstallationAborted ();
        }

        $db->query("INSERT INTO Module (Module_Name,Keyword,Description,Parameters,Subdivision_ID,Example_URL,Help_URL) VALUES ('$Name','$Keyword','$Description','$Parameters',0,'$ExampleURL','$HelpURL')");

        if ($SysMessage)
        {
            InsertSystemMessage($SysMessage,$Name);
        }

        CopyFiles ();

	//     ,   
	$current_catalogue = $db->get_row("SELECT * FROM Catalogue LIMIT 1",ARRAY_A);


        if ($current_catalogue['Language']=="ru")
        {
            ExecSQL ($TMP_FOLDER."sql.txt");
        }
        else
        {
            ExecSQL ($TMP_FOLDER."sql_int.txt");
        }

        DeleteFilesInDirectory ($TMP_FOLDER);

        TitleModule ();

        break;
}

EndHtml ();
?>